#include "global.hpp"
#define CLK PIN(TX)
#define MOSI_Pos PIN_RTS_Pos
#define MISO PIN(RX)
void packInArray(UCHAR *arr, uint32_t data) {
	for(int i=0; i<4*8; i++) {
		arr[2*i] = (!!(data & (1 << (31 - i)))) << MOSI_Pos;
		arr[2*i+1] = arr[2*i] | CLK;
	}
}

void packInArray2(UCHAR *arr, uint64_t data) {
	for(int i=0; i<4*8*2; i++) {
		arr[2*i] = (!!(data & (1 << (63 - i)))) << MOSI_Pos;
		arr[2*i+1] = arr[2*i] | CLK;
	}
}

uint32_t expandFromArray(UCHAR *arr) {
	uint32_t ret = 0;
	for(int i=0; i<32; i++) {
		ret |= (!!(arr[2*i + 1] & PIN_RX) << (31 - i));
	}
	return ret;
}

uint64_t expandFromArray2(UCHAR *arr) {
	uint64_t ret = 0;
	for(int i=0; i<32*2; i++) {
		ret |= (!!(arr[2*i + 1] & PIN_RX) << (63 - i));
	}
	return ret;
}
